

install.packages("VennDiagram")


library(VennDiagram)       
diseaseFile="hubGenes_MMyellow.txt"                
clusterFile="cluster.hubGenes_MMpink.txt"        
setwd("C:\\Users\\lenovo\\Desktop\\3\\19")    
geneList=list()

rt=read.table(diseaseFile, header=F, sep="\t", check.names=F)
geneNames=as.vector(rt[,1])            
geneNames=gsub("^ | $","",geneNames)     
uniqGene=unique(geneNames)               
geneList[["Disease WGCNA"]]=uniqGene     
rt=read.table(clusterFile, header=F, sep="\t", check.names=F)
geneNames=as.vector(rt[,1])              
geneNames=gsub("^ | $","",geneNames)     
uniqGene=unique(geneNames)              
geneList[["Cluster WGCNA"]]=uniqGene     


venn.plot=venn.diagram(geneList,filename=NULL,fill=c("cornflowerblue", "darkorchid1"),scaled=FALSE,cat.pos=c(-1,1),cat.col = c("cornflowerblue", "darkorchid1"),cat.cex=1)
pdf(file="venn.pdf", width=5, height=5)
grid.draw(venn.plot)
dev.off()


interGenes=Reduce(intersect,geneList)
write.table(file="interGenes.txt", interGenes, sep="\t", quote=F, col.names=F, row.names=F)



